package de.mlessmann.certassist.openssl;

import de.mlessmann.certassist.DeleteRecursiveFileVisitor;
import org.slf4j.Logger;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Set;

import static org.slf4j.LoggerFactory.getLogger;

public class OpenSSLCertificateResult implements AutoCloseable {

    private static final Logger LOGGER = getLogger(OpenSSLCertificateResult.class);

    private final Path tmpDir;

    OpenSSLCertificateResult(Path tmpDir) {
        this.tmpDir = tmpDir;
    }

    @Override
    public void close() throws IOException {
        LOGGER.info("Cleaning up temporary output directory {}", tmpDir);
        Files.walkFileTree(tmpDir, Set.of(), Integer.MAX_VALUE, new DeleteRecursiveFileVisitor());
        Files.deleteIfExists(tmpDir);
    }
}
